"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const AggregateRootImpl_1 = require("./AggregateRootImpl");
function factory(runFactory) {
    return async (parent, cmd) => {
        if (!parent) {
            throw new Error('Cannot run factory method. Parent state was null');
        }
        try {
            const ar = new AggregateRootImpl_1.AggregateRootImpl();
            return await ar.mutation(async (a, cmd, emitter) => {
                return runFactory(parent, cmd, emitter);
            })(cmd);
        }
        catch (error) {
            return new AggregateRootImpl_1.AggregateRootImpl(error);
        }
    };
}
exports.factory = factory;
